#define _REENTRANT
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <string.h>

void *thread_function(void *arg);
pthread_mutex_t work_mutex; /* protects both work_area and time_to_exit */
#define WORK_SIZE 1024
char work_area[WORK_SIZE];
char texts[3][50]={"First text\n",
                   "Second text\n",
                   "Third text\n"
                  };
int main() {
    int res;
    pthread_t a_thread;
    void *thread_result;
    int i=0,j=0;
    res = pthread_mutex_init(&work_mutex, NULL);
    if (res != 0) {
        perror("Mutex initialization failed");
        exit(EXIT_FAILURE);
    }
    res = pthread_create(&a_thread, NULL, thread_function, NULL);
    if (res != 0) {
        perror("Thread creation failed");
        exit(EXIT_FAILURE);
    }
    while(j<15) {
        pthread_mutex_lock(&work_mutex);
            strcpy(work_area,texts[i]);
        pthread_mutex_unlock(&work_mutex);
        i = (i + 1) % 3;
        j++;
        sleep(2);
    }
    printf("Bye\n");
    res = pthread_join(a_thread, &thread_result);
    if (res != 0) {
        perror("Thread join failed");
        exit(EXIT_FAILURE);
    }
    pthread_mutex_destroy(&work_mutex);
    exit(EXIT_SUCCESS);
}

void *thread_function(void *arg) {
    int i=0;
    while(i<20) {
        pthread_mutex_lock(&work_mutex);
            printf("Current text: %s",work_area);
        pthread_mutex_unlock(&work_mutex);
        sleep(1);
        i++;
    }
    pthread_exit(0);
}

