

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <pthread.h>
#include <semaphore.h>
#include <assert.h>
#include <sys/stat.h>
#include <sys/file.h>

#define BSIZE 4 // Buffer size
#define LSIZE 80 // Line length
typedef struct { // Shared data
char buf[BSIZE][LSIZE];
int head;
int tail;
int cnt;
} bufor_t;
bufor_t shared_memory;
bufor_t* shared_stuff;
#define NUM_PROD 3
pthread_t a_prod_thread[NUM_PROD];
#define NUM_CONS 2
pthread_t a_cons_thread[NUM_CONS];
void *prod_thread_function(void *arg);
void *cons_thread_function(void *arg);
void *thread_result;
sem_t *mutex;
sem_t *empty;
sem_t *full;

int main(){
    int res;
    int i;
    shared_stuff = &shared_memory;
    shared_stuff->head=0;
    shared_stuff->tail=0;
    shared_stuff->cnt=0;
    mutex = sem_open("mutex",O_CREAT,S_IRWXU,1);
    empty = sem_open("empty",O_CREAT,S_IRWXU,BSIZE);
    full =  sem_open("full",O_CREAT,S_IRWXU,0);
    // Producers:
    printf("Producers are created...\n");
    for(i=0;i<NUM_PROD;i++)
    {   res = pthread_create(&(a_prod_thread[i]), NULL,
prod_thread_function, (void *)i);
        if (res != 0) { perror("Thread creation failed");
                        exit(EXIT_FAILURE); }
    }
    // Consumers:
    printf("Consumers are created...\n");
    for(i=0;i<NUM_CONS;i++)
    {   res = pthread_create(&(a_cons_thread[i]), NULL,
cons_thread_function, (void *)i);
        if (res != 0) { perror("Thread creation failed");
                        exit(EXIT_FAILURE); }
    }
    printf("Waiting for producer threads to finish...\n");
    for(i = NUM_PROD - 1; i >= 0; i--) {
        res = pthread_join(a_prod_thread[i], &thread_result);
        if (res == 0) { printf("Picked up a thread\n");}
        else { perror("pthread_join failed");}
    }
    printf("Waiting for consumer threads to finish...\n");
    for(i = NUM_CONS - 1; i >= 0; i--) {
        res = pthread_join(a_prod_thread[i], &thread_result);
        if (res == 0) { printf("Picked up a thread\n"); }
        else { perror("pthread_join failed"); }
    }
    printf("All done\n");
    exit(EXIT_SUCCESS);
}

void *prod_thread_function(void *arg) {
    int my_number = (int)arg;
    printf("Producer %d is running\n",my_number);
    sleep(1);
    while(1){
        static int j=0;
        sem_wait(empty);
        sem_wait(mutex);
        printf("Producer %d - cnt: %d head: %d tail: %d\n",
                my_number, shared_stuff->
cnt,shared_stuff->head,shared_stuff->tail);
        sprintf(shared_stuff->buf[shared_stuff->head],"Message %d from
producer %d",j++,my_number);
        shared_stuff-> cnt ++;
        shared_stuff->head = (shared_stuff->head +1) % BSIZE;
        sem_post(mutex);
        sem_post(full);
        sleep(8);
    }
    printf("Bye from producer %d\n", my_number);
    pthread_exit(NULL);
}

void *cons_thread_function(void *arg) {
    int my_number = (int)arg;
    printf("Consumer %d is running\n",my_number);
    sleep(2);
    while(1) {
        sem_wait(full);
        sem_wait(mutex);
        printf("Consumer %d - cnt: %d data received: %s\n",
               my_number,
shared_stuff->cnt,shared_stuff->buf[shared_stuff->tail]);
        shared_stuff-> cnt --;
        shared_stuff->tail = (shared_stuff->tail +1) % BSIZE;
        sem_post(mutex);
        sem_post(empty);
        sleep(1);
    }
    printf("Bye from Consumer %d\n", my_number);
    pthread_exit(NULL);
}


