

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <mqueue.h>
#include <sys/stat.h>
#include <sys/wait.h>

struct message {
char mtext[128];
  };

void producer(int prod_no, mqd_t qid){
    int j= 0, r;
    struct message mes;
    while(1){
    sprintf(mes.mtext,"Message %d from producer %d",j++,prod_no);
    r = mq_send(qid, mes.mtext, strlen(mes.mtext) + 1, 1);
    if (r == -1) { perror("mq_send"); break;}
    sleep(3);
    }
}

void consumer(int cons_no, mqd_t qid){
    u_int pri;
    struct message msg;
    ssize_t len;
    while(1){
    len = mq_receive(qid, (char *) &msg, sizeof(msg), &pri);
    if (len == -1) { perror("mq_receive"); break;}
    printf("Consumer %d, data received: %s\n",
               cons_no, msg.mtext);
    }
}

int main(int argc, char *argv[])
  {
  // Allow up to 10 messages before blocking.
  // Message size is 128 bytes (see above).
  struct mq_attr mattr = {
  .mq_maxmsg = 10,
  .mq_msgsize = sizeof(struct message)
  };

  mqd_t mqid = mq_open("/myq",
  O_CREAT | O_RDWR,
  S_IREAD | S_IWRITE,
  &mattr);

  if (mqid == (mqd_t) -1) { perror("mq_open"); exit(1); }

  // Fork a producer process, we'll be the consumer.
  pid_t pid = fork();
  if (pid == 0) {
  producer(0,mqid);
  mq_close(mqid);
  exit(0);
  }
  else {
  consumer(0,mqid);
  mq_close(mqid);

  int status;
  wait(&status);
  }

  mq_unlink("/myq");
  return 0;
  }

