#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/wait.h>
#include <pthread.h>
#include <semaphore.h>
#include <assert.h>
#include <sys/stat.h>
#include <sys/file.h>

#define BSIZE 4 // Rozmiar bufora
#define LSIZE 80 // Dlugosc linii
typedef struct { // Obszar wspólny
char buf[BSIZE][LSIZE];
int head;
int tail;
int cnt;
} bufor_t;

int main()
{
    sem_t *mutex;
    sem_t *empty;
    sem_t *full;
    int shmid;
    void *shared_memory = (void *)0;
    bufor_t *shared_stuff;
    int i=0;

    shmid = shmget((key_t)1234, sizeof(bufor_t), 0666 | IPC_CREAT);

    if (shmid == -1) {
        fprintf(stderr, "shmget failed\n");
        exit(EXIT_FAILURE);
    }
    shared_memory = shmat(shmid, (void *)0, 0);
    if (shared_memory == (void *)-1) {
        fprintf(stderr, "shmat failed\n");
        exit(EXIT_FAILURE);
    }

    printf("Memory attached at %X\n", (int)shared_memory);
    shared_stuff = (bufor_t *)shared_memory;

    shared_stuff->head=0;
    shared_stuff->tail=0;
    shared_stuff->cnt=0;

    mutex = sem_open("mutex",O_CREAT,S_IRWXU,1);
    empty = sem_open("empty",O_CREAT,S_IRWXU,BSIZE);
    full =  sem_open("full",O_CREAT,S_IRWXU,0);

    //Producenci:
    printf("Tworze producentow...\n");
    {
        if(fork()==0)
        {   printf("Producent %d uruchominy\n",i);
            sleep(1);
            while(1)
            {   static int j=0;
                sem_wait(empty);
                sem_wait(mutex);
                printf("Producent %d - cnt: %d head: %d tail: %d\n",
                        i, shared_stuff-> cnt,shared_stuff->head,shared_stuff->tail);
                sprintf(shared_stuff->buf[shared_stuff->head],"Komunikat %d producent %d",j++,i);
                shared_stuff-> cnt ++;
                shared_stuff->head = (shared_stuff->head +1) % BSIZE;
                sem_post(mutex);
                sem_post(full);
                sleep(1);
            }
            exit(0);
        }
    }
    printf("Tworze konsumentów...\n");
    {
        if(fork()==0)
        {
            printf("Konsument %d uruchominy\n",i);
            sleep(2);
            while(1)
            {
             sem_wait(full);
             sem_wait(mutex);
             printf("Konsument %d - cnt: %d odebrano %s\n",
                        i, shared_stuff->cnt,shared_stuff->buf[shared_stuff->tail]);
             shared_stuff-> cnt --;
             shared_stuff->tail = (shared_stuff->tail +1) % BSIZE;
             sem_post(mutex);
             sem_post(empty);
             sleep(1);
            }
            exit(0);
        }
    }

    {
        int stat_val;
        pid_t child_pid;
        for(i=0;i<2;i++)
        child_pid = wait(&stat_val);
    }
    return 0;
}
